<?php

namespace Focus\Generalmanager\Repositories\Presenter;

use League\Fractal\TransformerAbstract;
use Hashids;

class GeneralmanagerTransformer extends TransformerAbstract
{
    public function transform(\Focus\Generalmanager\Models\Generalmanager $generalmanager)
    {
        return [
            'id'                => $generalmanager->getRouteKey(),
            'key'               => [
                'public'    => $generalmanager->getPublicKey(),
                'route'     => $generalmanager->getRouteKey(),
            ], 
            'id'                => $generalmanager->id,
            'salesman_id'       => $generalmanager->salesman_id,
            'reporting_to'      => $generalmanager->reporting_to,
            'name'              => $generalmanager->name,
            'email'             => $generalmanager->email,
            'password'          => $generalmanager->password,
            'api_token'         => $generalmanager->api_token,
            'remember_token'    => $generalmanager->remember_token,
            'sex'               => $generalmanager->sex,
            'dob'               => $generalmanager->dob,
            'designation'       => $generalmanager->designation,
            'mobile'            => $generalmanager->mobile,
            'phone'             => $generalmanager->phone,
            'address'           => $generalmanager->address,
            'street'            => $generalmanager->street,
            'city'              => $generalmanager->city,
            'district'          => $generalmanager->district,
            'state'             => $generalmanager->state,
            'country'           => $generalmanager->country,
            'photo'             => $generalmanager->photo,
            'web'               => $generalmanager->web,
            'permissions'       => $generalmanager->permissions,
            'status'            => $generalmanager->status,
            'user_id'           => $generalmanager->user_id,
            'user_type'         => $generalmanager->user_type,
            'upload_folder'     => $generalmanager->upload_folder,
            'deleted_at'        => $generalmanager->deleted_at,
            'created_at'        => $generalmanager->created_at,
            'updated_at'        => $generalmanager->updated_at,
            'url'               => [
                'public'    => trans_url('generalmanager/'.$generalmanager->getPublicKey()),
                'user'      => guard_url('generalmanager/generalmanager/'.$generalmanager->getRouteKey()),
            ], 
            'status'            => trans('app.'.$generalmanager->status),
            'created_at'        => format_date($generalmanager->created_at),
            'updated_at'        => format_date($generalmanager->updated_at),
        ];
    }
}